stages:
  - test
  - deploy
#
# Download the Salesforce CLI and install it
#commented encryption line
before_script:
  # Decrypt server key
  #- openssl aes-256-cbc -d -md md5 -in assets/server.key.enc -out assets/server.key -k $SERVER_KEY_PASSWORD

  # Set up environment variables
  - export CLIURL=https://developer.salesforce.com/media/salesforce-cli/sfdx-linux-amd64.tar.xz  
  - export SFDX_AUTOUPDATE_DISABLE=false
  - export SFDX_USE_GENERIC_UNIX_KEYCHAIN=true
  - export SFDX_DOMAIN_RETRY=300
  - export SFDX_DISABLE_APP_HUB=true
  - export SFDX_LOG_LEVEL=DEBUG
  - export DEPLOYDIR=src
  # - export TESTLEVEL=RunLocalTests

  #Create sfdx directory
  - mkdir sfdx

  #Install Salesforce CLI 
  - wget -qO- $CLIURL | tar xJ -C sfdx --strip-components 1
  - "./sfdx/install"
  - export PATH=./sfdx/$(pwd):$PATH

  # Output CLI version and plug-in information
  - sfdx --version
  - sfdx plugins --core

#added comments
# The script step authenticates to the target deployment org and deploys the metadata
#
validate deployment: 
  stage: test
  allow_failure: false
  when: manual
  only:
    refs:
      - qa
  script:
  # Authorize target deployment org
  - sfdx force:auth:jwt:grant --instanceurl https://login.salesforce.com --clientid $SF_CONSUMER_KEY --jwtkeyfile assets/server.key --username $SF_USERNAME 

  # Run a check-only deploy
  - sfdx force:mdapi:deploy --checkonly --wait 10 --deploydir $DEPLOYDIR --targetusername  $SF_USERNAME  --testlevel $TESTLEVEL


deploy to salesforce: 
  stage: deploy
  when: manual
  only:
    refs:
      - qa
  script:
  # Authorize target deployment org
  - sfdx force:auth:jwt:grant --instanceurl https://login.salesforce.com --clientid $SF_CONSUMER_KEY --jwtkeyfile assets/server.key --username $SF_USERNAME  

  # Deploy to target deployment org and run unit tests
  - sfdx force:mdapi:deploy --wait 10 --deploydir $DEPLOYDIR --targetusername $SF_USERNAME --testlevel $TESTLEVEL

  # NoTestRun—No tests are run. This test level applies only to deployments to development environments, such as sandbox, Developer Edition, or trial orgs. This test level is the default for development environments.

  # RunSpecifiedTests—Runs only the tests that you specify in the --runtests option. Code coverage requirements differ from the default coverage requirements when using this test level. Executed tests must comprise a minimum of 75% code coverage for each class and trigger in the deployment package. This coverage is computed for each class and trigger individually and is different than the overall coverage percentage.

  # RunLocalTests—All tests in your org are run, except the ones that originate from installed managed packages. This test level is the default for production deployments that include Apex classes or triggers.

  # RunAllTestsInOrg—All tests in your org are run, including tests of managed packages.